"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const chalk_1 = require("chalk");
const cli_framework_1 = require("@ionic/cli-framework");
const namespace_1 = require("@ionic/cli-utils/lib/namespace");
class CapacitorNamespace extends namespace_1.Namespace {
    getMetadata() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const groups = [cli_framework_1.NamespaceGroup.Beta];
            if (!this.env.config.get('features.capacitor-commands')) {
                groups.push(cli_framework_1.NamespaceGroup.Hidden);
            }
            return {
                name: 'capacitor',
                summary: 'Capacitor functionality',
                description: `
These commands integrate with Capacitor, Ionic's new native layer project which provides an alternative to Cordova for native functionality in your app.

Learn more about Capacitor:
- Main documentation: ${chalk_1.default.bold('https://capacitor.ionicframework.com/')}
      `,
                groups,
            };
        });
    }
    getCommands() {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            return new namespace_1.CommandMap([
                ['add', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { AddCommand } = yield Promise.resolve().then(() => require('./add')); return new AddCommand(this); })],
                ['copy', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { CopyCommand } = yield Promise.resolve().then(() => require('./copy')); return new CopyCommand(this); })],
                ['open', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { OpenCommand } = yield Promise.resolve().then(() => require('./open')); return new OpenCommand(this); })],
                ['sync', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { SyncCommand } = yield Promise.resolve().then(() => require('./sync')); return new SyncCommand(this); })],
                ['update', () => tslib_1.__awaiter(this, void 0, void 0, function* () { const { UpdateCommand } = yield Promise.resolve().then(() => require('./update')); return new UpdateCommand(this); })],
            ]);
        });
    }
}
exports.CapacitorNamespace = CapacitorNamespace;
